<?php
/* Autor...:  */
/* Esquema.: SR_DevolucionDetalle.xml */
/* Generado: 2021-07-06 18:57:55 */

/* Metodos de acceso a los campos de la tabla SR_DevolucionDetalle */
abstract class BaseSR_DevolucionDetalleBN
{
    /* Campos de la tabla */
    private $i_DevolucionDetId;    // DevolucionDetId: ( no definido )
    private $i_DevolucionCabId;    // DevolucionCabId: ( no definido )
    private $s_EstadoDevolucionId;    // EstadoDevolucionId: ( no definido )
    private $s_IdItem;    // IdItem: ( no definido )
    private $s_ItemDescripcion;    // ItemDescripcion: ( no definido )
    private $f_CantidadDevolucion;    // CantidadDevolucion: ( no definido )
    private $s_ComentarioDevolucion;    // ComentarioDevolucion: ( no definido )
    private $s_TipoComentDevolucion;    // TipoComentDevolucion: ( no definido )
    private $s_EstadoFacturacion;    // EstadoFacturacion: ( no definido )
    private $i_DevolFactId;    // DevolFactId: ( no definido )
    private $f_PrecioUnitVentaDevolucion;    // PrecioUnitVentaDevolucion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )

    /* Establece el valor del campo DevolucionDetId */
    public function setDevolucionDetId( $i_DevolucionDetId )
    {
        $this->i_DevolucionDetId = $i_DevolucionDetId;
    }

    /* Obtiene el valor del campo DevolucionDetId */
    public function getDevolucionDetId()
    {
        return $this->i_DevolucionDetId;
    }

    /* Establece el valor del campo DevolucionCabId */
    public function setDevolucionCabId( $i_DevolucionCabId )
    {
        $this->i_DevolucionCabId = $i_DevolucionCabId;
    }

    /* Obtiene el valor del campo DevolucionCabId */
    public function getDevolucionCabId()
    {
        return $this->i_DevolucionCabId;
    }

    /* Establece el valor del campo EstadoDevolucionId */
    public function setEstadoDevolucionId( $s_EstadoDevolucionId )
    {
        $this->s_EstadoDevolucionId = $s_EstadoDevolucionId;
    }

    /* Obtiene el valor del campo EstadoDevolucionId */
    public function getEstadoDevolucionId()
    {
        return $this->s_EstadoDevolucionId;
    }

    /* Establece el valor del campo IdItem */
    public function setIdItem( $s_IdItem )
    {
        $this->s_IdItem = $s_IdItem;
    }

    /* Obtiene el valor del campo IdItem */
    public function getIdItem()
    {
        return $this->s_IdItem;
    }

    /* Establece el valor del campo ItemDescripcion */
    public function setItemDescripcion( $s_ItemDescripcion )
    {
        $this->s_ItemDescripcion = $s_ItemDescripcion;
    }

    /* Obtiene el valor del campo ItemDescripcion */
    public function getItemDescripcion()
    {
        return $this->s_ItemDescripcion;
    }

    /* Establece el valor del campo CantidadDevolucion */
    public function setCantidadDevolucion( $f_CantidadDevolucion )
    {
        $this->f_CantidadDevolucion = $f_CantidadDevolucion;
    }

    /* Obtiene el valor del campo CantidadDevolucion */
    public function getCantidadDevolucion()
    {
        return $this->f_CantidadDevolucion;
    }

    /* Establece el valor del campo ComentarioDevolucion */
    public function setComentarioDevolucion( $s_ComentarioDevolucion )
    {
        $this->s_ComentarioDevolucion = $s_ComentarioDevolucion;
    }

    /* Obtiene el valor del campo ComentarioDevolucion */
    public function getComentarioDevolucion()
    {
        return $this->s_ComentarioDevolucion;
    }

    /* Establece el valor del campo TipoComentDevolucion */
    public function setTipoComentDevolucion( $s_TipoComentDevolucion )
    {
        $this->s_TipoComentDevolucion = $s_TipoComentDevolucion;
    }

    /* Obtiene el valor del campo TipoComentDevolucion */
    public function getTipoComentDevolucion()
    {
        return $this->s_TipoComentDevolucion;
    }

    /* Establece el valor del campo EstadoFacturacion */
    public function setEstadoFacturacion( $s_EstadoFacturacion )
    {
        $this->s_EstadoFacturacion = $s_EstadoFacturacion;
    }

    /* Obtiene el valor del campo EstadoFacturacion */
    public function getEstadoFacturacion()
    {
        return $this->s_EstadoFacturacion;
    }

    /* Establece el valor del campo DevolFactId */
    public function setDevolFactId( $i_DevolFactId )
    {
        $this->i_DevolFactId = $i_DevolFactId;
    }

    /* Obtiene el valor del campo DevolFactId */
    public function getDevolFactId()
    {
        return $this->i_DevolFactId;
    }

    /* Establece el valor del campo PrecioUnitVentaDevolucion */
    public function setPrecioUnitVentaDevolucion( $f_PrecioUnitVentaDevolucion )
    {
        $this->f_PrecioUnitVentaDevolucion = $f_PrecioUnitVentaDevolucion;
    }

    /* Obtiene el valor del campo PrecioUnitVentaDevolucion */
    public function getPrecioUnitVentaDevolucion()
    {
        return $this->f_PrecioUnitVentaDevolucion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'DevolucionDetId' => $this->getDevolucionDetId(),
            'DevolucionCabId' => $this->getDevolucionCabId(),
            'EstadoDevolucionId' => $this->getEstadoDevolucionId(),
            'IdItem' => $this->getIdItem(),
            'ItemDescripcion' => $this->getItemDescripcion(),
            'CantidadDevolucion' => $this->getCantidadDevolucion(),
            'ComentarioDevolucion' => $this->getComentarioDevolucion(),
            'TipoComentDevolucion' => $this->getTipoComentDevolucion(),
            'EstadoFacturacion' => $this->getEstadoFacturacion(),
            'DevolFactId' => $this->getDevolFactId(),
            'PrecioUnitVentaDevolucion' => $this->getPrecioUnitVentaDevolucion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto SR_DevolucionDetalleBN desde un RecordSet */
    public static function retrieveByRs( $o_SR_DevolucionDetalleRs )
    {
        $o_SR_DevolucionDetalleBN = new SR_DevolucionDetalleBN();
        $o_SR_DevolucionDetalleBN->setDevolucionDetId( ( integer ) $o_SR_DevolucionDetalleRs[ "DevolucionDetId" ] );
        $o_SR_DevolucionDetalleBN->setDevolucionCabId( ( integer ) $o_SR_DevolucionDetalleRs[ "DevolucionCabId" ] );
        $o_SR_DevolucionDetalleBN->setEstadoDevolucionId( $o_SR_DevolucionDetalleRs[ "EstadoDevolucionId" ] );
        $o_SR_DevolucionDetalleBN->setIdItem( $o_SR_DevolucionDetalleRs[ "IdItem" ] );
        $o_SR_DevolucionDetalleBN->setItemDescripcion( $o_SR_DevolucionDetalleRs[ "ItemDescripcion" ] );
        $o_SR_DevolucionDetalleBN->setCantidadDevolucion( ( float ) $o_SR_DevolucionDetalleRs[ "CantidadDevolucion" ] );
        $o_SR_DevolucionDetalleBN->setComentarioDevolucion( $o_SR_DevolucionDetalleRs[ "ComentarioDevolucion" ] );
        $o_SR_DevolucionDetalleBN->setTipoComentDevolucion( $o_SR_DevolucionDetalleRs[ "TipoComentDevolucion" ] );
        $o_SR_DevolucionDetalleBN->setEstadoFacturacion( $o_SR_DevolucionDetalleRs[ "EstadoFacturacion" ] );
        $o_SR_DevolucionDetalleBN->setDevolFactId( ( integer ) $o_SR_DevolucionDetalleRs[ "DevolFactId" ] );
        $o_SR_DevolucionDetalleBN->setPrecioUnitVentaDevolucion( ( float ) $o_SR_DevolucionDetalleRs[ "PrecioUnitVentaDevolucion" ] );
        $o_SR_DevolucionDetalleBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_SR_DevolucionDetalleRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_SR_DevolucionDetalleBN->setUsuarioCreacion( $o_SR_DevolucionDetalleRs[ "UsuarioCreacion" ] );
        return $o_SR_DevolucionDetalleBN;
    }
}
?>